package nl.sbdeveloper.themeparkplus.managers;

import com.google.gson.Gson;
import nl.SBDevelopment.SBUtilities.Data.SQLiteDB;
import nl.SBDevelopment.SBUtilities.Utils.LocationSerializer;
import nl.sbdeveloper.themeparkplus.api.PlusAPI;
import nl.sbdeveloper.themeparkplus.api.objects.Gate;
import org.bukkit.Location;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Map;

public class DBManager {

    private static SQLiteDB data;
    private static Connection con;

    public DBManager(String name) {
        data = new SQLiteDB(name);

        try {
            con = data.getConnection();

            String query = "CREATE TABLE IF NOT EXISTS gates (gateLocation varchar(255) NOT NULL, gateData blob NOT NULL, UNIQUE (gateLocation))";
            PreparedStatement statement = con.prepareStatement(query);
            statement.execute();
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    public void load() throws SQLException {
        /* Load gates */
        String query = "SELECT * FROM gates";
        PreparedStatement statement = con.prepareStatement(query);
        ResultSet gateSet = statement.executeQuery();
        while (gateSet.next()) {
            //Loading a gates...
            byte[] blob = gateSet.getBytes("gateData");
            String json = new String(blob);

            Gson gson = new Gson();
            Gate gate = gson.fromJson(json, Gate.class);
            PlusAPI.addGate(gate);
        }
    }

    public void save() {
        for (Map.Entry<Location, Gate> entry : PlusAPI.getGates().entrySet()) {

            Gson gson = new Gson();
            byte[] blob = gson.toJson(entry.getValue()).getBytes();

            try {
                String query = "INSERT INTO gates (gateLocation, gateData) VALUES (?, ?)";
                PreparedStatement statement = con.prepareStatement(query);
                statement.setString(1, LocationSerializer.serialize(entry.getKey()));
                statement.setBytes(2, blob);
                statement.executeUpdate();
            } catch (SQLException ignored) {}

            try {
                String query2 = "UPDATE gates SET gateData = ? WHERE gateLocation = ?";
                PreparedStatement statement2 = con.prepareStatement(query2);
                statement2.setBytes(1, blob);
                statement2.setString(2, LocationSerializer.serialize(entry.getKey()));
                statement2.executeUpdate();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    public void closeConnection() {
        data.closeSource();
    }

}
